## rbdoom3bfg 1.2.0+dfsg~git20191014

=== neo/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

project(RBDoom3BFG)

option(USE_MFC_TOOLS
		"Compile the built-in MFC based tools" OFF)
		
option(MONOLITH
		"Embed game logic into main executable" ON)

option(USE_PRECOMPILED_HEADERS
		"Use precompiled headers during build" ON)
		
option(SDL2
		"Use SDL2 instead of SDL1.2" ON)
		
option(OPENAL
		"Use OpenAL soft instead of XAudio2" OFF)

option(FFMPEG
		"Use FMPEG to render Bink videos" OFF)

option(BINKDEC
		"Use included libbinkdec to render Bink videos" ON)
		
option(USE_VULKAN
		"Use Vulkan instead of OpenGL" OFF)

option(ONATIVE
		"Optimize for the host CPU" OFF)
		
option(WINRT
		"Build for Windows RT" OFF)
		
option(WINDOWS10
		"Build for Windows 10" OFF)
		
option(USE_SYSTEM_ZLIB
                "Use the system zlib instead of the bundled one" OFF)

option(USE_SYSTEM_LIBPNG
                "Use the system libpng instead of the bundled one" OFF)

option(USE_SYSTEM_LIBJPEG
                "Use the system libjpeg instead of the bundled one" OFF)

option(USE_SYSTEM_LIBGLEW
                "Use the system libglew instead of the bundled one" OFF)

option(USE_SYSTEM_RAPIDJSON
                "Use the system rapidjson instead of the bundled one" OFF)

set(CPU_TYPE "" CACHE STRING "When set, passes this string as CPU-ID which will be embedded into the binary.")

set(CPU_OPTIMIZATION "-mmmx -msse -msse2" CACHE STRING "Which CPU specific optimitations should be used beside the compiler's default?")

option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" ON)

if(FFMPEG AND BINKDEC)
	message(FATAL_ERROR "Only one of FFMPEG and BINKDEC (or neither) can be enabled at a time")
endif()

if(UNIX)
	set(OPENAL TRUE)
endif()
		
if(MSVC)
	#message(STATUS CMAKE_ROOT: ${CMAKE_ROOT})
	
	#if(CMAKE_CL_64)
	#	SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/../bin/win64)
	#else()
	#	SET(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/../bin/win32)
	#endif()
	
	#message(STATUS EXECUTABLE_OUTPUT_PATH: ${EXECUTABLE_OUTPUT_PATH})
	#message(STATUS PROJECT_BINARY_DIR: ${PROJECT_BINARY_DIR})
	#message(STATUS CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR})
else()
	message(STATUS CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE})
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
	add_definitions(-pipe)
	#add_definitions(-Wall)
	add_definitions(-Werror=format-security)
	add_definitions(-Werror=format)
	if(CPU_TYPE)
		add_definitions(-DCPUSTRING="${CPU_TYPE}")
	endif()
	if (CPU_OPTIMIZATION)
		add_definitions(${CPU_OPTIMIZATION})
	endif()
	if (USE_INTRINSICS)
		add_definitions(-DUSE_INTRINSICS)
	endif()
	if(WIN32)
		# require msvcr70.dll or newer for _aligned_malloc etc
		# I think it is from Visual C++ .NET 2002, so it should be available on any remotely modern system.
		add_definitions(-D__MSVCRT_VERSION__=0x0700)
		
		find_package(DirectX REQUIRED)
		include_directories(libs/mingw-hacks)
		include_directories(${DirectX_INCLUDE_DIR})
		add_definitions(-DUSE_XINPUT)
	endif()	
	
	#if(NOT ANDROID)
		add_definitions(-DUSE_EXCEPTIONS)
	#endif()
	
	add_compile_options(-Wno-pragmas -Wno-unused-variable -Wno-switch -Wno-unused-value -Winvalid-pch -Wno-multichar)
	if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
		# add clang-specific settings for warnings (the second one make sure clang doesn't complain
		# about unknown -W flags, like -Wno-unused-but-set-variable)
		add_compile_options(-Wno-local-type-template-args -Wno-unknown-warning-option -Wno-inline-new-delete -Wno-switch-enum)
	endif()
	
	if(NOT CMAKE_CROSSCOMPILING AND ONATIVE)
		add_definitions(-march=native)
	endif()

	add_compile_options(-fno-strict-aliasing)

	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -O0 -ggdb")
	#set(CMAKE_C_FLAGS_DEBUGALL "${CMAKE_C_FLAGS_DEBUGALL} -g -ggdb -D_DEBUG")
	#set(CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_PROFILE} -g -ggdb -D_DEBUG -O1 -fno-omit-frame-pointer")
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
	set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -g -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
	set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Os -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
	
	set(CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
	#set(CMAKE_CXX_FLAGS_DEBUGALL ${CMAKE_C_FLAGS_DEBUGALL})
	#set(CMAKE_CXX_FLAGS_PROFILE ${CMAKE_C_FLAGS_PROFILE})
	set(CMAKE_CXX_FLAGS_RELEASE ${CMAKE_C_FLAGS_RELEASE})
	set(CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_C_FLAGS_RELWITHDEBINFO})
	set(CMAKE_CXX_FLAGS_MINSIZEREL ${CMAKE_C_FLAGS_MINSIZEREL})

elseif(MSVC)
	
	# Multiprocessor support for compiling
	# /MP
	
	# /MT  use multithreaded, static runtime library
	#      (=> binary won't need MSVCP100D.dll or similar)
	# /MTd the same with debug symbols
	# /MD and /MDd - the same with dynamic runtime lib
	#     (=> MSVCP100D.dll or similar is needed to run binary)

	# Inline Function Expansion: Any Suitable (/Ob2)
	# "/Ob2",
			
	# enable Intrinsic Functions
	# "/Oi",
			
	# Omit Frame Pointers
	# "/Oy",
	
	# if(MSVC_VERSION EQUAL 1700)
		# #message(STATUS "$ENV{LIBPATH}")
		
		# find_path(Windows_winmd_DIR NAMES Windows.winmd
			# HINTS
			# C:/Program Files (x86)/Windows Kits/8.0/References/CommonConfiguration/Neutral
			# PATH_SUFFIXES "Neutral")
			
		# message(STATUS "${Windows_winmd_DIR}")
		
		# #set(WINRT_OPTIONS "/ZW /D USE_WINRT /AI \"C:\Program Files (x86)\Windows Kits\8.0\References\CommonConfiguration\Neutral\"")
		# #set(WINRT_OPTIONS "/ZW /D USE_WINRT /AI \"$ENV{LIBPATH}\" ")
		# set(WINRT_OPTIONS "/ZW /D USE_WINRT")
	
		# set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /D _DEBUG /MP ${WINRT_OPTIONS}")
		# set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MP /Oi /Oy ${WINRT_OPTIONS}")
		# set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /MP /Oi ${WINRT_OPTIONS}")
		# set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} /MP /Oi /Oy ${WINRT_OPTIONS}")
		
		# set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MP ${WINRT_OPTIONS}")
		# set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MP /Oi /Oy ${WINRT_OPTIONS}")
		# set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /MP ${WINRT_OPTIONS}")
		# set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /MP /Oi /Oy ${WINRT_OPTIONS}")
	# else()
		set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /D _DEBUG /MP /MDd")
		set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MP /Oi /Oy /MD")
		set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} /MP /Oi /MDd")
		set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} /MP /Oi /Oy /MD")
		
		set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MP /MDd")
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MP /Oi /Oy /MD")
		set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /MP /MDd")
		set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /MP /Oi /Oy /MD")
		
		# RB: without /SAFESEH:NO we can't link against ffmpeg libs and VS2013 or we have to build our own
		# libs for newer compilers
		set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /SAFESEH:NO")
		set(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL} /SAFESEH:NO")
		set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /SAFESEH:NO")
		set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /SAFESEH:NO")
	# endif()
	

	add_definitions(-DWIN32 
					-D_WINDOWS
					-D_CRT_SECURE_NO_DEPRECATE
					-D_CRT_NONSTDC_NO_DEPRECATE
					-D_CRT_SECURE_NO_WARNINGS
                                        -D_MBCS
                                       #-DUSE_OPENAL
					-DUSE_EXCEPTIONS)
        ## Check for Version ##
        if( WINRT OR WINDOWS10 ) # Windows RT
			add_definitions(-DUSE_WINRT)
        endif()

        if (USE_INTRINSICS)
			add_definitions(-DUSE_INTRINSICS)
        endif()
					
	if(NOT CMAKE_CL_64)
		add_definitions(-D_USE_32BIT_TIME_T)
	endif()
					
	if(USE_MFC_TOOLS)
		add_definitions(-D_AFXDLL)
		
		# 0: Use Standard Windows Libraries
		# 1: Use MFC in a Static Library
		# 2: Use MFC in a Shared DLL 
		set(CMAKE_MFC_FLAG 2)
	endif()
endif()

#if(STANDALONE)
#	add_definitions(-DSTANDALONE)
#endif()

if (USE_SYSTEM_ZLIB)
  find_package(ZLIB REQUIRED)
endif(USE_SYSTEM_ZLIB)

if (ZLIB_FOUND)
    include_directories(${ZLIB_INCLUDE_DIRS})
    set(ZLIB_LIBRARY ${ZLIB_LIBRARIES})
else (ZLIB_FOUND)
    include_directories("libs/zlib")
    set(ZLIB_LIBRARY "" )
endif (ZLIB_FOUND)

if(USE_SYSTEM_LIBPNG)
find_package(PNG REQUIRED)
endif (USE_SYSTEM_LIBPNG)

if (PNG_FOUND)
    include_directories(${PNG_INCLUDE_DIRS})
    set(PNG_LIBRARY ${PNG_LIBRARIES})
else (PNG_FOUND)
    include_directories("libs/png")
    set(PNG_LIBRARY "" )
endif (PNG_FOUND)


if(USE_SYSTEM_LIBJPEG)
find_package(JPEG REQUIRED)
endif(USE_SYSTEM_LIBJPEG)

if (JPEG_FOUND)
    include_directories(${JPEG_INCLUDE_DIRS})
    set(JPEG_LIBRARY ${JPEG_LIBRARIES})
    add_definitions(-DUSE_NEWER_JPEG)
else (JPEG_FOUND)
    include_directories("libs/jpeg-6")
    set(JPEG_LIBRARY "" )
endif (JPEG_FOUND)


macro(SET_OPTION option value)
  set(${option} ${value} CACHE "" INTERNAL FORCE)
endmacro()

if(USE_VULKAN)
	# Use FindVulkan module added with CMAKE 3.7
	if(NOT CMAKE_VERSION VERSION_LESS 3.7.0)
		message( STATUS "Using module to find Vulkan" )
		find_package(Vulkan)
	endif()
	
	
	if(NOT Vulkan_FOUND)
		message(FATAL_ERROR "Could not find Vulkan library!")
	else()
		message(STATUS ${Vulkan_LIBRARY})
	endif()
	
	add_definitions(-DUSE_VULKAN)
	include_directories($ENV{VK_SDK_PATH}/Include)
	
	# override Glslang build options
	SET_OPTION(ENABLE_SPVREMAPPER OFF)
	SET_OPTION(ENABLE_GLSLANG_BINARIES OFF)
	SET_OPTION(ENABLE_HLSL OFF)
	#SET_OPTION(ENABLE_OPT OFF)
	
	#option(ENABLE_AMD_EXTENSIONS "Enables support of AMD-specific extensions" ON)
	#option(ENABLE_NV_EXTENSIONS "Enables support of Nvidia-specific extensions" ON)
	#option(ENABLE_OPT "Enables spirv-opt capability if present" ON)
	
	set(GLSLANG_DIR ${CMAKE_CURRENT_SOURCE_DIR}/libs/glslang)
	add_subdirectory(${GLSLANG_DIR})
	
	include_directories(${GLSLANG_DIR}/glslang)

else()

	if(USE_SYSTEM_LIBGLEW)
		find_package(GLEW)
	endif()

	if(GLEW_FOUND)
		include_directories(${GLEW_INCLUDE_DIRS})
		set(GLEW_LIBRARY ${GLEW_LIBRARIES})
	else()
		include_directories("libs/glew/include")
		set(GLEW_LIBRARY "" )
		add_definitions(-DGLEW_STATIC)
		
		set(GLEW_INCLUDES libs/glew/include/GL/glew.h)
		set(GLEW_SOURCES libs/glew/src/glew.c)

		if(WIN32)
			set(GLEW_INCLUDES ${GLEW_INCLUDES} libs/glew/include/GL/wglew.h)
		else()
			set(GLEW_INCLUDES ${GLEW_INCLUDES} libs/glew/include/GL/glxew.h)
		endif()
		
	endif()
endif()

if(USE_SYSTEM_RAPIDJSON)
find_package(rapidjson REQUIRED)
endif(USE_SYSTEM_RAPIDJSON)

if (RAPIDJSON_FOUND)
	include_directories("${RAPIDJSON_INCLUDE_DIRS}")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${RAPIDJSON_CXX_FLAGS}")
else (RAPIDJSON_FOUND)
	include_directories("libs/rapidjson/include")
endif (RAPIDJSON_FOUND)


	
add_subdirectory(idlib)

file(GLOB AAS_INCLUDES aas/*.h)
file(GLOB AAS_SOURCES aas/*.cpp)

file(GLOB_RECURSE CM_INCLUDES cm/*.h)
file(GLOB_RECURSE CM_SOURCES cm/*.cpp)

file(GLOB FRAMEWORK_INCLUDES framework/*.h)
file(GLOB FRAMEWORK_SOURCES framework/*.cpp)

file(GLOB FRAMEWORK_ASYNC_INCLUDES framework/async/*.h)
file(GLOB FRAMEWORK_ASYNC_SOURCES framework/async/*.cpp)

file(GLOB RENDERER_INCLUDES renderer/*.h)
file(GLOB RENDERER_SOURCES renderer/*.cpp)
file(GLOB RENDERER_COLOR_INCLUDES renderer/Color/*.h)
file(GLOB RENDERER_COLOR_SOURCES renderer/Color/*.cpp)
file(GLOB RENDERER_DXT_INCLUDES renderer/DXT/*.h)
file(GLOB RENDERER_DXT_SOURCES renderer/DXT/*.cpp)
file(GLOB RENDERER_JOBS_INCLUDES renderer/jobs/*.h)
file(GLOB RENDERER_JOBS_SOURCES renderer/jobs/*.cpp)
file(GLOB RENDERER_JOBS_DYNAMICSHADOWVOLUME_INCLUDES renderer/jobs/dynamicshadowvolume/*.h)

=== debian/changelog ===
rbdoom3bfg (1.2.0+dfsg~git20191014-2) unstable; urgency=medium

  * Do not use the packaged FindSDL2 package. Closes: #951976
    - New patch 100-fix-sdl2-detection.patch
    - B-D on libsdl-dev (>= 2.0.4) to mitigate #951087.
    Many thanks Simon McVittie for hinting into the right direction.

 -- Tobias Frost <tobi@debian.org>  Sun, 23 Feb 2020 17:21:40 +0100

rbdoom3bfg (1.2.0+dfsg~git20191014-1) unstable; urgency=medium

  * New upstream release, upstream versioned it as 1.2.0-preview1.
  * Refresh patches as needed to remove fuzz.
  * New patch 90-fix-include-path to fix FTBFS with new upstream source.
  * Fix new typo found by lintian in the spelling error patch.
  * Delete 30-init-sdl2.patch, unapplied since a few versions.
  * Drop 70-disable-hdr-by-default.patch, underlaying issue has been
    fixed upstream.
  * Bump S-V to 4.4.1 -- no changes required except specifying
    rules-requires-root=no.
  * Drop d/compat in favour of debhelper-compat (=12) as B-D.

 -- Tobias Frost <tobi@debian.org>  Tue, 15 Oct 2019 20:30:51 +0200

=== debian/control ===
Source: rbdoom3bfg
Section: games
Priority: optional
Maintainer: Tobias Frost <tobi@debian.org>
Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libglew-dev,
               libjpeg-dev,
               libopenal-dev,
               libpng-dev,
               libsdl2-dev (>=2.0.4),
               libswscale-dev,
               rapidjson-dev,
               zlib1g-dev
Standards-Version: 4.4.1
Rules-Requires-Root: no
Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
VCS-Browser: https://salsa.debian.org/games-team/rbdoom3bfg
VCS-Git: https://salsa.debian.org/games-team/rbdoom3bfg.git

Package: rbdoom3bfg
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: doom3bfg-data | game-data-packager (>= 40)
Description: Doom3 BFG edition game engine
 RBDoom3BFG 3 is a Doom 3 BFG GPL source modification. The goal of RBDoom3BFG 3
 is to bring Doom 3 BFG with the help of SDL to all suitable platforms. Bugs
 present in the original DOOM 3 will be fixed (when identified) without altering
 the original game-play.
 .
 Note, to play the original game, you'll need a copy of the game data.
 .
 The package can also be used with free map data, like the demomap from
 OpenTechBFG.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# output every command that modifies files on the build system.
#DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

CMAKE_ADDTIONAL_FLAGS ?=
ifeq ($(findstring $(DEB_BUILD_ARCH), amd64 kfreebsd-amd64),)
CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS=OFF
endif

%:
	dh $@ --sourcedirectory=neo

override_dh_auto_configure:
	dh_auto_configure -- -G "Unix Makefiles" \
	 -DSDL2=ON -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	 -DUSE_SYSTEM_ZLIB=ON -DUSE_SYSTEM_LIBPNG=ON \
	 -DUSE_SYSTEM_LIBJPEG=ON -DUSE_SYSTEM_LIBGLEW=ON \
         -DUSE_SYSTEM_RAPIDJSON=ON \
	 -DCPU_TYPE=$(DEB_BUILD_ARCH_CPU) \
	 -DUSE_PRECOMPILED_HEADERS=OFF \
	 -DCPU_OPTIMIZATION="" \
	 $(CMAKE_ADDITIONAL_FLAGS)

override_dh_installchangelogs:
	# We won't have a ChangeLog if packaging from a released tarball.
	# In this case, use the RELEASE-NOTES.txt
	dh_installchangelogs
	if [ ! -e ChangeLog ]; then \
	dh_installchangelogs -k RELEASE-NOTES.txt ; \
	fi

## rbdoom3bfg 1.2.0+dfsg~git20200817

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,13 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 2.8) # Eric: These are rookie numbers, you need to bump those numbers up.
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
 
 project(RBDoom3BFG)
+
+option(FORCE_COLOR_OUTPUT
+		"Always produce ANSI-colored output (GNU/Clang only)." OFF)
+
+option(COMPILE_COMMANDS
+		"Generate compile_commands.json" OFF)
 
 option(USE_MFC_TOOLS
 		"Compile the built-in MFC based tools" OFF)
@@ -19,14 +25,17 @@
 		"Use OpenAL soft instead of XAudio2" OFF)
 
 option(FFMPEG
-		"Use FMPEG to render Bink videos" OFF)
+		"Use FMPEG to render Bink videos" ON)
 
 option(BINKDEC
-		"Use included libbinkdec to render Bink videos" ON)
+		"Use included libbinkdec to render Bink videos" OFF)
 		
 option(USE_VULKAN
 		"Use Vulkan instead of OpenGL" OFF)
 
+option(SPIRV_SHADERC
+		"Compile SPIR-V shader byte code using shaderc instead of using Glslang directly" OFF)
+
 option(ONATIVE
 		"Optimize for the host CPU" OFF)
 		
@@ -53,7 +62,9 @@
 
 set(CPU_TYPE "" CACHE STRING "When set, passes this string as CPU-ID which will be embedded into the binary.")
 
-set(CPU_OPTIMIZATION "-mmmx -msse -msse2" CACHE STRING "Which CPU specific optimitations should be used beside the compiler's default?")
+if (CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
+	set(CPU_OPTIMIZATION "-mmmx -msse -msse2" CACHE STRING "Which CPU specific optimitations should be used beside the compiler's default?")
+endif()
 
 option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" ON)
 
@@ -64,7 +75,26 @@
 if(UNIX)
 	set(OPENAL TRUE)
 endif()
-		
+
+if(COMPILE_COMMANDS)
+	set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+endif()
+
+if (FORCE_COLOR_OUTPUT)
+	if (CMAKE_COMPILER_IS_GNUCC)
+		add_compile_options(-fdiagnostics-color=always)
+	elseif(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+		add_compile_options(-fcolor-diagnostics)
+	endif ()
+endif ()
+
+# Eric: Hard dependency on SDL2 for the Vulkan renderer on Linux
+if(UNIX)
+	if(USE_VULKAN)
+		SET(SDL2 ON)
+	endif()
+endif()
+
 if(MSVC)
 	#message(STATUS CMAKE_ROOT: ${CMAKE_ROOT})
 	
@@ -86,6 +116,18 @@
 	#add_definitions(-Wall)
 	add_definitions(-Werror=format-security)
 	add_definitions(-Werror=format)
+
+	# Compiler check (needs -std=c++11 flag)
+	include(CheckCXXCompilerFlag)
+	CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
+	if(COMPILER_SUPPORTS_CXX11)
+		set(CMAKE_CXX_STANDARD 11)
+		set(CMAKE_CXX_STANDARD_REQUIRED ON)
+		set(CMAKE_CXX_EXTENSIONS OFF)
+	else()
+		message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
+	endif()
+
 	if(CPU_TYPE)
 		add_definitions(-DCPUSTRING="${CPU_TYPE}")
 	endif()
@@ -284,8 +326,7 @@
 		message( STATUS "Using module to find Vulkan" )
 		find_package(Vulkan)
 	endif()
-	
-	
+
 	if(NOT Vulkan_FOUND)
 		message(FATAL_ERROR "Could not find Vulkan library!")
 	else()
@@ -293,82 +334,47 @@
 	endif()
 	
 	add_definitions(-DUSE_VULKAN)
-	include_directories($ENV{VK_SDK_PATH}/Include)
-	
-	# override Glslang build options
-	SET_OPTION(ENABLE_SPVREMAPPER OFF)
-	SET_OPTION(ENABLE_GLSLANG_BINARIES OFF)
-	SET_OPTION(ENABLE_HLSL OFF)
-	#SET_OPTION(ENABLE_OPT OFF)
-	
-	#option(ENABLE_AMD_EXTENSIONS "Enables support of AMD-specific extensions" ON)
-	#option(ENABLE_NV_EXTENSIONS "Enables support of Nvidia-specific extensions" ON)
-	#option(ENABLE_OPT "Enables spirv-opt capability if present" ON)
-	
-	set(GLSLANG_DIR ${CMAKE_CURRENT_SOURCE_DIR}/libs/glslang)
-	add_subdirectory(${GLSLANG_DIR})
-	
-	include_directories(${GLSLANG_DIR}/glslang)
-
-else()
-
-	if(USE_SYSTEM_LIBGLEW)
-		find_package(GLEW)
-	endif()
-
-	if(GLEW_FOUND)
-		include_directories(${GLEW_INCLUDE_DIRS})
-		set(GLEW_LIBRARY ${GLEW_LIBRARIES})
+	include_directories($ENV{VULKAN_SDK}/include)
+
+	# Eric: For use with SDL2/Vulkan
+	if(UNIX)
+		find_package(X11_XCB)
+		if(X11_XCB_FOUND)
+			add_definitions(-DHAVE_X11_XCB)
+			list(APPEND SUBSYSTEMS [X11])
+			include_directories(${X11_XCB_INCLUDE_DIRS})
+		endif()
+		add_definitions(-DVK_USE_PLATFORM_XLIB_KHR)
+	elseif(WIN32)
+		add_definitions(-DVK_USE_PLATFORM_WIN32_KHR)
+	endif()
+
+	if(SPIRV_SHADERC)
+		add_definitions(-DSPIRV_SHADERC)
+
+		if(CMAKE_CL_64)
+			link_directories($ENV{VULKAN_SDK}/Lib)
+		else()
+			link_directories($ENV{VULKAN_SDK}/Lib32)
+		endif()
+
 	else()
-		include_directories("libs/glew/include")
-		set(GLEW_LIBRARY "" )
-		add_definitions(-DGLEW_STATIC)
-		
-		set(GLEW_INCLUDES libs/glew/include/GL/glew.h)
-		set(GLEW_SOURCES libs/glew/src/glew.c)
-
-		if(WIN32)
-			set(GLEW_INCLUDES ${GLEW_INCLUDES} libs/glew/include/GL/wglew.h)
-		else()
-			set(GLEW_INCLUDES ${GLEW_INCLUDES} libs/glew/include/GL/glxew.h)
-		endif()
-		
-	endif()
-endif()
-
-if(USE_SYSTEM_RAPIDJSON)
-find_package(rapidjson REQUIRED)
-endif(USE_SYSTEM_RAPIDJSON)
-
-if (RAPIDJSON_FOUND)
-	include_directories("${RAPIDJSON_INCLUDE_DIRS}")
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${RAPIDJSON_CXX_FLAGS}")
-else (RAPIDJSON_FOUND)
-	include_directories("libs/rapidjson/include")
-endif (RAPIDJSON_FOUND)
-
-
-	
-add_subdirectory(idlib)
-
-file(GLOB AAS_INCLUDES aas/*.h)
-file(GLOB AAS_SOURCES aas/*.cpp)
-
-file(GLOB_RECURSE CM_INCLUDES cm/*.h)
-file(GLOB_RECURSE CM_SOURCES cm/*.cpp)
-
-file(GLOB FRAMEWORK_INCLUDES framework/*.h)
-file(GLOB FRAMEWORK_SOURCES framework/*.cpp)
-
-file(GLOB FRAMEWORK_ASYNC_INCLUDES framework/async/*.h)
-file(GLOB FRAMEWORK_ASYNC_SOURCES framework/async/*.cpp)
-
-file(GLOB RENDERER_INCLUDES renderer/*.h)
-file(GLOB RENDERER_SOURCES renderer/*.cpp)
-file(GLOB RENDERER_COLOR_INCLUDES renderer/Color/*.h)
-file(GLOB RENDERER_COLOR_SOURCES renderer/Color/*.cpp)
-file(GLOB RENDERER_DXT_INCLUDES renderer/DXT/*.h)
-file(GLOB RENDERER_DXT_SOURCES renderer/DXT/*.cpp)
-file(GLOB RENDERER_JOBS_INCLUDES renderer/jobs/*.h)
-file(GLOB RENDERER_JOBS_SOURCES renderer/jobs/*.cpp)
-file(GLOB RENDERER_JOBS_DYNAMICSHADOWVOLUME_INCLUDES renderer/jobs/dynamicshadowvolume/*.h)
+		# override Glslang build options
+		
+		# options required by November 2018 release
+		SET_OPTION(ENABLE_SPVREMAPPER OFF)
+		SET_OPTION(ENABLE_GLSLANG_BINARIES OFF)
+		SET_OPTION(ENABLE_HLSL OFF)
+		SET_OPTION(ENABLE_OPT ON)
+		SET_OPTION(SPIRV_SKIP_EXECUTABLES ON)
+		
+		# options required by November 2019 release
+		#SET_OPTION(ENABLE_PCH OFF)
+		#SET_OPTION(ENABLE_CTEST OFF)
+		#SET_OPTION(BUILD_EXTERNAL OFF)
+		#SET_OPTION(SKIP_GLSLANG_INSTALL ON)
+	
+		set(GLSLANG_DIR ${CMAKE_CURRENT_SOURCE_DIR}/extern/glslang)
+		add_subdirectory(${GLSLANG_DIR})
+	
+		include_directories(${GLSLANG_DIR}/glslang)

=== debian/changelog ===
rbdoom3bfg (1.2.0+dfsg~git20200817-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Refresh 10-lowercase-executable.patch
  * Add patch to fix FTBFS with relative include path.
  * lintian-overides: Use wildcard to stop complains about spelling errors.

 -- Tobias Frost <tobi@debian.org>  Tue, 25 Aug 2020 15:54:05 +0200

rbdoom3bfg (1.2.0+dfsg~git20200619-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Drop patches 40-libpng16.patch and 50-fix-imgui-includepath.patch;
      they have been applied upstream.
    - Refresh patch 10-lowercase-executable.patch.
  * Make (pedantic) lintian a bit happier
    - s/VCS/Vcs in d/control.
    - remove --as-needed from linker flags in d/rules.
    - ignore one more spelling error.
  * Use debhelper compat level 13.
  * Fix "rbdoom3bfg FTCBFS: confuses build and host", thanks to Helmut for
    the patch. (Closes: #962428)

 -- Tobias Frost <tobi@debian.org>  Sun, 05 Jul 2020 19:45:53 +0200

rbdoom3bfg (1.2.0+dfsg~git20200327-1) unstable; urgency=medium

  * New upstream git snapshot.
  * Updating patches:
      - Refresh 10-lowercase-executable.patch.
      - Remove 20-reproducible.patch, should no longer be needed.
      - Refresh 40-libpng16.patch.
      - Remove 60-spelling-errors.patch, upstream will never accept it and it
        starts to become a burden.
      - Remove 90-fix-include-path.patch, applied upstream.
      - Remove 100-fix-sdl2-detection.patch, applied upstream.
      - New patch 50-fix-imgui-includepath.patch, otherwise it will fail to
        compile.
  * Upstream moved around some docs, adapting d/docs, d/install and d/rules
    accordingly.
  * Update SV, no changes.

 -- Tobias Frost <tobi@debian.org>  Tue, 31 Mar 2020 11:27:50 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Tobias Frost <tobi@debian.org>
 Uploaders: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libavcodec-dev,
                libavformat-dev,
                libavutil-dev,
@@ -16,11 +16,11 @@
                libswscale-dev,
                rapidjson-dev,
                zlib1g-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
-VCS-Browser: https://salsa.debian.org/games-team/rbdoom3bfg
-VCS-Git: https://salsa.debian.org/games-team/rbdoom3bfg.git
+Vcs-Browser: https://salsa.debian.org/games-team/rbdoom3bfg
+Vcs-Git: https://salsa.debian.org/games-team/rbdoom3bfg.git
 
 Package: rbdoom3bfg
 Architecture: any

## rbdoom3bfg 1.2.0+dfsg~git20210105

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -66,7 +66,11 @@
 	set(CPU_OPTIMIZATION "-mmmx -msse -msse2" CACHE STRING "Which CPU specific optimitations should be used beside the compiler's default?")
 endif()
 
-option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" ON)
+if(CMAKE_SYSTEM_PROCESSOR MATCHES "((powerpc|ppc)64le)|(mips64)")
+	option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" OFF)
+else()
+	option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" ON)
+endif()
 
 if(FFMPEG AND BINKDEC)
 	message(FATAL_ERROR "Only one of FFMPEG and BINKDEC (or neither) can be enabled at a time")
@@ -247,8 +251,8 @@
 					-D_CRT_SECURE_NO_DEPRECATE
 					-D_CRT_NONSTDC_NO_DEPRECATE
 					-D_CRT_SECURE_NO_WARNINGS
-                                        -D_MBCS
-                                       #-DUSE_OPENAL
+					-D_MBCS
+					#-DUSE_OPENAL
 					-DUSE_EXCEPTIONS)
         ## Check for Version ##
         if( WINRT OR WINDOWS10 ) # Windows RT
@@ -321,33 +325,9 @@
 endmacro()
 
 if(USE_VULKAN)
-	# Use FindVulkan module added with CMAKE 3.7
-	if(NOT CMAKE_VERSION VERSION_LESS 3.7.0)
-		message( STATUS "Using module to find Vulkan" )
-		find_package(Vulkan)
-	endif()
-
-	if(NOT Vulkan_FOUND)
-		message(FATAL_ERROR "Could not find Vulkan library!")
-	else()
-		message(STATUS ${Vulkan_LIBRARY})
-	endif()
-	
-	add_definitions(-DUSE_VULKAN)
-	include_directories($ENV{VULKAN_SDK}/include)
-
-	# Eric: For use with SDL2/Vulkan
-	if(UNIX)
-		find_package(X11_XCB)
-		if(X11_XCB_FOUND)
-			add_definitions(-DHAVE_X11_XCB)
-			list(APPEND SUBSYSTEMS [X11])
-			include_directories(${X11_XCB_INCLUDE_DIRS})
-		endif()
-		add_definitions(-DVK_USE_PLATFORM_XLIB_KHR)
-	elseif(WIN32)
-		add_definitions(-DVK_USE_PLATFORM_WIN32_KHR)
-	endif()
+
+	# RB: moved this above the general Vulkan part so glslang does not include Vulkan SDK headers
+	# which causes all kinds of weird segmentation faults because struct sizes don't match
 
 	if(SPIRV_SHADERC)
 		add_definitions(-DSPIRV_SHADERC)
@@ -362,19 +342,38 @@
 		# override Glslang build options
 		
 		# options required by November 2018 release
-		SET_OPTION(ENABLE_SPVREMAPPER OFF)
+		SET_OPTION(ENABLE_SPVREMAPPER ON)
 		SET_OPTION(ENABLE_GLSLANG_BINARIES OFF)
 		SET_OPTION(ENABLE_HLSL OFF)
 		SET_OPTION(ENABLE_OPT ON)
 		SET_OPTION(SPIRV_SKIP_EXECUTABLES ON)
 		
-		# options required by November 2019 release
-		#SET_OPTION(ENABLE_PCH OFF)
-		#SET_OPTION(ENABLE_CTEST OFF)
-		#SET_OPTION(BUILD_EXTERNAL OFF)
-		#SET_OPTION(SKIP_GLSLANG_INSTALL ON)
+		# options required by July 2020 release
+		SET_OPTION(ENABLE_PCH OFF)
+		SET_OPTION(ENABLE_CTEST OFF)
+		SET_OPTION(BUILD_EXTERNAL OFF)
+		SET_OPTION(SKIP_GLSLANG_INSTALL ON)
+
+		#add_definitions(-DGLSLANG_MINOR_VERSION=13)
 	
 		set(GLSLANG_DIR ${CMAKE_CURRENT_SOURCE_DIR}/extern/glslang)
 		add_subdirectory(${GLSLANG_DIR})
 	
 		include_directories(${GLSLANG_DIR}/glslang)
+		
+		#link_directories($ENV{VULKAN_SDK}/Lib)
+	endif()
+
+	# Use FindVulkan module added with CMAKE 3.7
+	if(NOT CMAKE_VERSION VERSION_LESS 3.7.0)
+		message( STATUS "Using module to find Vulkan" )
+		find_package(Vulkan)
+	endif()
+
+	if(NOT Vulkan_FOUND)
+		message(FATAL_ERROR "Could not find Vulkan library!")
+	else()
+		message(STATUS ${Vulkan_LIBRARY})
+	endif()
+	
+	add_definitions(-DUSE_VULKAN)

=== debian/changelog ===
rbdoom3bfg (1.2.0+dfsg~git20210105-1) unstable; urgency=low

  [ Tobias Frost ]
  * Disable repotest on salsa-CI.
  * New upstream git snapshot.
  * Refresh debian/patches/10-lowercase-executable.patch
  * Remove 20-fix-imgui-include.patch, applied upstream.
  * Add lintian override license-problem-json-evil, it is only quoted in a
    in a document but the library has been removed with the dfsg repacking.
  * Bump S-V to 4.5.1, no changes.
  * Update d/copyright years.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Tobias Frost <tobi@debian.org>  Wed, 03 Feb 2021 17:58:24 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                libswscale-dev,
                rapidjson-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
 Vcs-Browser: https://salsa.debian.org/games-team/rbdoom3bfg

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/architecture.mk
 include /usr/share/dpkg/pkg-info.mk
 
 # output every command that modifies files on the build system.
@@ -7,12 +8,9 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
-
-DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 
 CMAKE_ADDTIONAL_FLAGS ?=
-ifeq ($(findstring $(DEB_BUILD_ARCH), amd64 kfreebsd-amd64),)
+ifneq ($(DEB_HOST_ARCH_CPU),amd64)
 CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS=OFF
 endif
 
@@ -32,8 +30,8 @@
 
 override_dh_installchangelogs:
 	# We won't have a ChangeLog if packaging from a released tarball.
-	# In this case, use the RELEASE-NOTES.txt
+	# In this case, use the RELEASE-NOTES.md
 	dh_installchangelogs
 	if [ ! -e ChangeLog ]; then \
-	dh_installchangelogs -k RELEASE-NOTES.txt ; \
+	dh_installchangelogs -k RELEASE-NOTES.md ; \
 	fi

## rbdoom3bfg 1.3.0+dfsg

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,14 @@
-cmake_minimum_required(VERSION 2.8) # Eric: These are rookie numbers, you need to bump those numbers up.
+cmake_minimum_required(VERSION 3.2)
+
+project(RBDoom3BFG)
+
 set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
-
-project(RBDoom3BFG)
-
+set_property(GLOBAL PROPERTY USE_FOLDERS ON)
+if(CMAKE_MAJOR_VERSION EQUAL 3 AND CMAKE_MINOR_VERSION GREATER_EQUAL 6)
+	# set MSVC startup project
+	set_property (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT RBDoom3BFG)
+endif()
+	
 option(FORCE_COLOR_OUTPUT
 		"Always produce ANSI-colored output (GNU/Clang only)." OFF)
 
@@ -11,9 +17,6 @@
 
 option(USE_MFC_TOOLS
 		"Compile the built-in MFC based tools" OFF)
-		
-option(MONOLITH
-		"Embed game logic into main executable" ON)
 
 option(USE_PRECOMPILED_HEADERS
 		"Use precompiled headers during build" ON)
@@ -36,6 +39,9 @@
 option(SPIRV_SHADERC
 		"Compile SPIR-V shader byte code using shaderc instead of using Glslang directly" OFF)
 
+option(USE_MoltenVK
+		"Use MoltenVK library directly instead of Vulkan loader on macOS" OFF)
+
 option(ONATIVE
 		"Optimize for the host CPU" OFF)
 		
@@ -62,14 +68,16 @@
 
 set(CPU_TYPE "" CACHE STRING "When set, passes this string as CPU-ID which will be embedded into the binary.")
 
-if (CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
+# SRS - Turn on optimization when cross-compiling from Apple arm64 to x86_64
+if (CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)" OR CMAKE_OSX_ARCHITECTURES MATCHES "x86_64")
 	set(CPU_OPTIMIZATION "-mmmx -msse -msse2" CACHE STRING "Which CPU specific optimitations should be used beside the compiler's default?")
 endif()
 
-if(CMAKE_SYSTEM_PROCESSOR MATCHES "((powerpc|ppc)64le)|(mips64)")
-	option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" OFF)
+# SRS - Turn off MMX/SSE intrinsics when cross-compiling from Apple x86_64 to arm64
+if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)|(e2k)|(E2K)" AND NOT CMAKE_OSX_ARCHITECTURES MATCHES "arm64")
+	option(USE_INTRINSICS_SSE "Compile using SSE intrinsics (e.g mmx, sse, msse2)" ON)
 else()
-	option(USE_INTRINSICS "Compile using intrinsics (e.g mmx, sse, msse2)" ON)
+	option(USE_INTRINSICS_SSE "Compile using SSE intrinsics (e.g mmx, sse, msse2)" OFF)
 endif()
 
 if(FFMPEG AND BINKDEC)
@@ -77,7 +85,22 @@
 endif()
 
 if(UNIX)
-	set(OPENAL TRUE)
+	set(OPENAL ON)
+	
+    # SRS - Disable precompiled headers when cross-compiling on OSX, e.g. when creating universal binaries
+    if((CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "x86_64" AND CMAKE_OSX_ARCHITECTURES MATCHES "arm64" ) OR
+       (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "arm64"  AND CMAKE_OSX_ARCHITECTURES MATCHES "x86_64"))
+        set(USE_PRECOMPILED_HEADERS OFF)
+    endif()
+
+	if(USE_VULKAN)
+		SET(SDL2 ON)
+		
+		# RB: disable precompiled headers on Linux with Vulkan because of error: POSIX thread support was disabled in PCH file but is currently enabled
+		if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
+            set(USE_PRECOMPILED_HEADERS OFF)
+        endif()
+	endif()
 endif()
 
 if(COMPILE_COMMANDS)
@@ -87,17 +110,10 @@
 if (FORCE_COLOR_OUTPUT)
 	if (CMAKE_COMPILER_IS_GNUCC)
 		add_compile_options(-fdiagnostics-color=always)
-	elseif(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+	elseif(CMAKE_C_COMPILER_ID MATCHES "Clang")
 		add_compile_options(-fcolor-diagnostics)
 	endif ()
 endif ()
-
-# Eric: Hard dependency on SDL2 for the Vulkan renderer on Linux
-if(UNIX)
-	if(USE_VULKAN)
-		SET(SDL2 ON)
-	endif()
-endif()
 
 if(MSVC)
 	#message(STATUS CMAKE_ROOT: ${CMAKE_ROOT})
@@ -115,7 +131,8 @@
 	message(STATUS CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE})
 endif()
 
-if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
+if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
+
 	add_definitions(-pipe)
 	#add_definitions(-Wall)
 	add_definitions(-Werror=format-security)
@@ -138,9 +155,6 @@
 	if (CPU_OPTIMIZATION)
 		add_definitions(${CPU_OPTIMIZATION})
 	endif()
-	if (USE_INTRINSICS)
-		add_definitions(-DUSE_INTRINSICS)
-	endif()
 	if(WIN32)
 		# require msvcr70.dll or newer for _aligned_malloc etc
 		# I think it is from Visual C++ .NET 2002, so it should be available on any remotely modern system.
@@ -157,24 +171,42 @@
 	#endif()
 	
 	add_compile_options(-Wno-pragmas -Wno-unused-variable -Wno-switch -Wno-unused-value -Winvalid-pch -Wno-multichar)
-	if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+    if(CMAKE_C_COMPILER_ID MATCHES "Clang")
 		# add clang-specific settings for warnings (the second one make sure clang doesn't complain
 		# about unknown -W flags, like -Wno-unused-but-set-variable)
-		add_compile_options(-Wno-local-type-template-args -Wno-unknown-warning-option -Wno-inline-new-delete -Wno-switch-enum)
+		# SRS - Add -Wno-deprecated-register and -Wno-expansion-to-defined to list of warning settings
+		add_definitions(-Wno-local-type-template-args -Wno-unknown-warning-option -Wno-inline-new-delete -Wno-switch-enum -Wno-deprecated-register -Wno-expansion-to-defined)
 	endif()
 	
 	if(NOT CMAKE_CROSSCOMPILING AND ONATIVE)
-		add_definitions(-march=native)
+		if(CMAKE_SYSTEM_PROCESSOR MATCHES "((powerpc|ppc)64le)|(mips64)")
+			add_definitions(-mcpu=native)
+		else()
+			add_definitions(-march=native)
+		endif()
 	endif()
 
 	add_compile_options(-fno-strict-aliasing)
 
-	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -O0 -ggdb")
-	#set(CMAKE_C_FLAGS_DEBUGALL "${CMAKE_C_FLAGS_DEBUGALL} -g -ggdb -D_DEBUG")
-	#set(CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_PROFILE} -g -ggdb -D_DEBUG -O1 -fno-omit-frame-pointer")
-	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
-	set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -g -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
-	set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Os -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
+	# SRS - Make sure OSX can find system headers and add support for minimum OSX runtime version
+	if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+		# SRS - Also add -fasm-blocks otherwise Xcode complains and -Qunused-arguments to silence MMX/SSE unused arg warnings when compiling for Apple arm64
+		add_definitions(-fasm-blocks -Qunused-arguments)
+        if(CMAKE_OSX_SYSROOT)
+            add_definitions(-isysroot "${CMAKE_OSX_SYSROOT}")
+            message(STATUS "Using macOS sysroot: " ${CMAKE_OSX_SYSROOT})
+        endif()
+		if(CMAKE_OSX_DEPLOYMENT_TARGET)
+			add_definitions(-mmacosx-version-min="${CMAKE_OSX_DEPLOYMENT_TARGET}")
+		endif()
+	endif()
+
+    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -ggdb -D_DEBUG -O0")
+    #set(CMAKE_C_FLAGS_DEBUGALL "${CMAKE_C_FLAGS_DEBUGALL} -g -ggdb -D_DEBUG")
+    #set(CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_PROFILE} -g -ggdb -D_DEBUG -O1 -fno-omit-frame-pointer")
+	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffp-contract=off -fomit-frame-pointer -fno-math-errno -fno-trapping-math")
+	set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -g -O3 -ffp-contract=off -fomit-frame-pointer -fno-math-errno -fno-trapping-math")
+	set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Os -ffp-contract=off -fomit-frame-pointer -fno-math-errno -fno-trapping-math")
 	
 	set(CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
 	#set(CMAKE_CXX_FLAGS_DEBUGALL ${CMAKE_C_FLAGS_DEBUGALL})
@@ -244,7 +276,6 @@
 		set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /SAFESEH:NO")
 		set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /SAFESEH:NO")
 	# endif()
-	
 
 	add_definitions(-DWIN32 
 					-D_WINDOWS
@@ -252,16 +283,11 @@
 					-D_CRT_NONSTDC_NO_DEPRECATE
 					-D_CRT_SECURE_NO_WARNINGS
 					-D_MBCS
-					#-DUSE_OPENAL
 					-DUSE_EXCEPTIONS)
-        ## Check for Version ##
-        if( WINRT OR WINDOWS10 ) # Windows RT
-			add_definitions(-DUSE_WINRT)
-        endif()
-
-        if (USE_INTRINSICS)
-			add_definitions(-DUSE_INTRINSICS)
-        endif()
+
+	if( WINRT OR WINDOWS10 ) # Windows RT
+		add_definitions(-DUSE_WINRT)
+	endif()
 					
 	if(NOT CMAKE_CL_64)
 		add_definitions(-D_USE_32BIT_TIME_T)
@@ -275,6 +301,11 @@
 		# 2: Use MFC in a Shared DLL 
 		set(CMAKE_MFC_FLAG 2)
 	endif()
+
+endif()
+
+if (USE_INTRINSICS_SSE)
+	add_definitions(-DUSE_INTRINSICS_SSE)
 endif()
 
 #if(STANDALONE)
@@ -294,7 +325,7 @@
 endif (ZLIB_FOUND)
 
 if(USE_SYSTEM_LIBPNG)
-find_package(PNG REQUIRED)
+	find_package(PNG REQUIRED)
 endif (USE_SYSTEM_LIBPNG)
 
 if (PNG_FOUND)
@@ -302,78 +333,3 @@
     set(PNG_LIBRARY ${PNG_LIBRARIES})
 else (PNG_FOUND)
     include_directories("libs/png")
-    set(PNG_LIBRARY "" )
-endif (PNG_FOUND)
-
-
-if(USE_SYSTEM_LIBJPEG)
-find_package(JPEG REQUIRED)
-endif(USE_SYSTEM_LIBJPEG)
-
-if (JPEG_FOUND)
-    include_directories(${JPEG_INCLUDE_DIRS})
-    set(JPEG_LIBRARY ${JPEG_LIBRARIES})
-    add_definitions(-DUSE_NEWER_JPEG)
-else (JPEG_FOUND)
-    include_directories("libs/jpeg-6")
-    set(JPEG_LIBRARY "" )
-endif (JPEG_FOUND)
-
-
-macro(SET_OPTION option value)
-  set(${option} ${value} CACHE "" INTERNAL FORCE)
-endmacro()
-
-if(USE_VULKAN)
-
-	# RB: moved this above the general Vulkan part so glslang does not include Vulkan SDK headers
-	# which causes all kinds of weird segmentation faults because struct sizes don't match
-
-	if(SPIRV_SHADERC)
-		add_definitions(-DSPIRV_SHADERC)
-
-		if(CMAKE_CL_64)
-			link_directories($ENV{VULKAN_SDK}/Lib)
-		else()
-			link_directories($ENV{VULKAN_SDK}/Lib32)
-		endif()
-
-	else()
-		# override Glslang build options
-		
-		# options required by November 2018 release
-		SET_OPTION(ENABLE_SPVREMAPPER ON)
-		SET_OPTION(ENABLE_GLSLANG_BINARIES OFF)
-		SET_OPTION(ENABLE_HLSL OFF)
-		SET_OPTION(ENABLE_OPT ON)
-		SET_OPTION(SPIRV_SKIP_EXECUTABLES ON)
-		
-		# options required by July 2020 release
-		SET_OPTION(ENABLE_PCH OFF)
-		SET_OPTION(ENABLE_CTEST OFF)
-		SET_OPTION(BUILD_EXTERNAL OFF)
-		SET_OPTION(SKIP_GLSLANG_INSTALL ON)
-
-		#add_definitions(-DGLSLANG_MINOR_VERSION=13)
-	
-		set(GLSLANG_DIR ${CMAKE_CURRENT_SOURCE_DIR}/extern/glslang)
-		add_subdirectory(${GLSLANG_DIR})
-	
-		include_directories(${GLSLANG_DIR}/glslang)
-		
-		#link_directories($ENV{VULKAN_SDK}/Lib)
-	endif()
-
-	# Use FindVulkan module added with CMAKE 3.7
-	if(NOT CMAKE_VERSION VERSION_LESS 3.7.0)
-		message( STATUS "Using module to find Vulkan" )
-		find_package(Vulkan)
-	endif()
-
-	if(NOT Vulkan_FOUND)
-		message(FATAL_ERROR "Could not find Vulkan library!")
-	else()
-		message(STATUS ${Vulkan_LIBRARY})
-	endif()
-	
-	add_definitions(-DUSE_VULKAN)

=== debian/changelog ===
rbdoom3bfg (1.3.0+dfsg-2) unstable; urgency=medium

  * Fix build on i386: Upstream renamed the cmake option to disable
    CPU optimizations which are above the i386 baseline in Debian.

 -- Tobias Frost <tobi@debian.org>  Mon, 24 Jan 2022 14:16:26 +0100

rbdoom3bfg (1.3.0+dfsg-1) unstable; urgency=medium

  * Retire d/README.source, the information within was outdated
    regarding getting the source: Noweedays a simple uscan will cut it.
  * Update watch file to track the release upstream has made we are
    preparing.
  * Refresh patch 10-lowercase-executable.patch.
  * Review/Update d/copyright.
  * Update lintian overrides.
  * Update S-V to 4.6.0 -- no changes required.
  * Update d/upstream/metadata.

 -- Tobias Frost <tobi@debian.org>  Mon, 24 Jan 2022 13:29:10 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                libswscale-dev,
                rapidjson-dev,
                zlib1g-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
 Vcs-Browser: https://salsa.debian.org/games-team/rbdoom3bfg

=== debian/rules ===
--- 
+++ 
@@ -7,11 +7,10 @@
 #DH_VERBOSE = 1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 
 CMAKE_ADDTIONAL_FLAGS ?=
 ifneq ($(DEB_HOST_ARCH_CPU),amd64)
-CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS=OFF
+CMAKE_ADDITIONAL_FLAGS ?= -DUSE_INTRINSICS_SSE=OFF
 endif
 
 %:

=== debian/watch ===
version=4

# tracking upstream releases
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%, dversionmangle=s/\+dfsg\d*$//" \
   https://github.com/RobertBeckebans/RBDOOM-3-BFG/releases \
   (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

# tracking upstream commit based watch file (retained for the future tobi)
#opts="mode=git, pgpmode=none, pretty=1.2.0+dfsg~git%cd, dversionmangle=s/\+dfsg\d*$//" \
#https://github.com/RobertBeckebans/RBDOOM-3-BFG.git \
#HEAD debian uupdate

## rbdoom3bfg 1.4.0%2Bdfsg

=== debian/changelog ===
rbdoom3bfg (1.4.0+dfsg-7ubuntu2) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Sep 2025 09:49:51 +0200

rbdoom3bfg (1.4.0+dfsg-7ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3
    - Comment out for now imgui build fix until new version reaches Ubuntu

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Sep 2025 09:31:55 +0200

rbdoom3bfg (1.4.0+dfsg-7) unstable; urgency=medium

  * Fix build against ffmpeg 8.0 (Closes: #1115040)

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 13 Sep 2025 10:26:16 +0200

rbdoom3bfg (1.4.0+dfsg-6ubuntu2) questing; urgency=medium

  * Comment out for now imgui build fix, we still have the old version

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 02 Sep 2025 14:32:22 +0200

rbdoom3bfg (1.4.0+dfsg-6ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 02 Sep 2025 10:32:54 +0200

rbdoom3bfg (1.4.0+dfsg-6) unstable; urgency=medium

  * Fix build with CMake 4 (Closes: #1113459)
  * Fix build against libimgui-dev 1.92.2

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 01 Sep 2025 08:02:43 +0200

rbdoom3bfg (1.4.0+dfsg-5ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Mar 2025 14:28:03 +0100

rbdoom3bfg (1.4.0+dfsg-5) unstable; urgency=medium

  * d/rbdoom3bfg.desktop: use game-data-packager's launcher
  * d/control: recommends game-data-packager-runtime
  * update S-V to 4.7.2 -- no changes required.

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 12 Mar 2025 14:13:55 +0100

rbdoom3bfg (1.4.0+dfsg-4ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 09 Nov 2024 20:27:16 +0100

rbdoom3bfg (1.4.0+dfsg-4) unstable; urgency=medium

  * Adopt package and set Maintainer to Debian Games Team (Closes: #1035299)
  * Install a desktop file in /usr/share/applications
  * Add d/p/spelling.patch to correct spelling errors spotted by Lintian

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 06 Nov 2024 13:59:36 +0100

rbdoom3bfg (1.4.0+dfsg-3ubuntu1) oracular; urgency=medium

  * Fix build failure on ppc64el with -O3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Jul 2024 20:14:06 +0200

rbdoom3bfg (1.4.0+dfsg-3) unstable; urgency=medium

  * Set Maintainer to the QA Group.
  * Fix building with ffmpeg 7.0 (Closes: #1072448)
  * Set minimum version of rapidjson due to #1074897.

 -- Tobias Frost <tobi@debian.org>  Mon, 29 Jul 2024 10:28:10 +0200

rbdoom3bfg (1.4.0+dfsg-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Avoid including ../../imgui/imgui.h. (Closes: #1028279)

  [ Tobias Frost ]
  * Update copyright years.
  * Bump to SV 4.6.2 -- no changed.

 -- Tobias Frost <tobi@debian.org>  Thu, 19 Jan 2023 15:33:57 +0100

rbdoom3bfg (1.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Remove bundled imgui and use Debian packaged one instead.
    - Refresh patch.
    - It is compatible with ffmpeg 5.0. (Closes: #1004574)
  * Update/Review d/copyright.
  * New patch to utilize packaged imgui.
  * d/control: Remove no longer needed versions from constraints.

 -- Tobias Frost <tobi@debian.org>  Mon, 28 Mar 2022 11:15:37 +0200
